var updatestartlist = function()
{
	var updatestartlist = {};
	
	var debug = 0;
	
	// Page initialization
	updatestartlist.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', updatestartlist.validateStep1);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', updatestartlist.submit);

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=GetProcessedStartItemLists';
		url += '&orderDesc=true';		
		Wizard.showLoadingAnimation('Loading items...');
		Wizard.asyncJsonRequest(url, updatestartlist.initializeStep1);
	}

	updatestartlist.initializeStep1 = function(response)
	{
		var frm = document.forms['meludi'];
		var itemLists = response.itemLists;
		
		var startItemList = frm.startItemList;
//alert("initializeStep1(): itemLists.length = " + itemLists.length);
		if (itemLists.length > 0)
		{
			for (var i=0; i < itemLists.length; i++)
			{
				var itemList = itemLists[i];
				var name = (i+1) + ': ' + Strings.encodeTags(itemList.name);
				if (itemList.sourceItemNames)
				{
					name += ' -- (';
					name += itemList.numMeludiItems;
					name += ' + ' + itemList.numExtraItems;
					name += ')';
				}
				if (itemList.extractionDate)
				{
					name += ' -- [' + updatestartlist.asDate(itemList.extractionDate) + ']';
				}
/*
				var selected = i == (itemLists.length - 1);
				var option = new Option(name, itemList.id, selected, selected);
				option.itemList = itemList;
				startItemList.options[startItemList.length] = option;
*/
				var selected = true;
				// Only include start item lists with no value for extractionOperator annotation
//alert("initializeStep1(): i = " + i + " itemList.name = " + itemList.name + " itemList.extractionOperator = " + itemList.extractionOperator);
				if (itemList.extractionOperator = 'undefined' || (itemList.extractionOperator != null && itemList.extractionOperator != ''))
				{
					var option = new Option(name, itemList.id, selected, selected);
					option.itemList = itemList;
					startItemList.options[startItemList.length] = option;
				}
			}
/*
			startItemList.options[0].selected = true;
*/
		}
		else
		{
			Wizard.setFatalError('No start lists available.');
			return;
		}
		Doc.show('step-1');
		Doc.show('gocancel');
		Doc.hide('gonext');
		Doc.show('goregister');
		Doc.hide('extractSourceItems');
	}

	updatestartlist.validateStep1 = function(event)
	{
		var frm = document.forms['meludi'];
		var jsonStartListIds = [];
		var numSelected = 0;
		for (var i = 0; i < frm.startItemList.length; i++)
		{
			if (frm.startItemList[i].selected)
			{
				var jsonStartList = {};
				jsonStartList.id = frm.startItemList[i].value;
				jsonStartListIds[numSelected] = jsonStartList;
				numSelected++;
			}
		}
		if (numSelected == 0)
		{
			event.preventDefault();
		}
	}
	
	updatestartlist.submit = function()
	{
		var frm = document.forms['meludi'];
		//var startItemList = null;
		var jsonStartItemListIds = [];
		var numSelected = 0;
		for (var i = 0; i < frm.startItemList.length; i++)
		{
			if (frm.startItemList[i].selected)
			{
				var jsonStartItemList = {};
				jsonStartItemList.id = frm.startItemList[i].value;
				jsonStartItemListIds[numSelected] = jsonStartItemList;
				numSelected++;
			}
		}
		if (numSelected == 0)
		{
			event.preventDefault();
		}

		frm.startItemList.disabled = true;

		var submitInfo = {};
		
		submitInfo.startitemlists = jsonStartItemListIds;

		var url = '../Extraction.servlet?ID='+App.getSessionId();
		url += '&cmd=UpdateStartListsWithLotNumbersFromExtracts';
		Wizard.showLoadingAnimation('Performing registration...');
		Wizard.asyncJsonRequest(url, updatestartlist.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	updatestartlist.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}


	// Format value as a date in format yyyy-mm-dd
	updatestartlist.asDate = function(value)
	{
		if (!value) return '';
		if (value.length == 8)
		{
			value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
		}
		return value;
	}

	return updatestartlist;
}();

Doc.onLoad(updatestartlist.initPage);
